def temp-table tt1 field f1 as int.

def var l1 as longchar case-sensitive.
def var l2 as longchar init "foo" no-undo not case-sensitive.
def var ch as char case-sensitive.
def var ch1 as char.
def var ch2 as char init "bar" not case-sensitive.

def new shared var chs1 as char case-sensitive.
def new global shared var chs2 as char not case-sensitive.
def shared var chs3 as char not case-sensitive.

def new shared var ls1 as longchar case-sensitive.
def new global shared var ls2 as longchar not case-sensitive.
def shared var ls3 as longchar not case-sensitive.

function lcfunc0 returns longchar(ll as longchar):
  return ll.
end.

function lcfunc1 returns longchar(output ll as longchar):
  return ll.
end.

function lcfunc2 returns char(ll as longchar):
  return string(ll).
end.

function chfunc0 returns longchar(ll as char):
  return ll.
end.

function chfunc1 returns longchar(output ll as char):
  return ll.
end.

function chfunc2 returns char(ll as char):
  return string(ll).
end.

chs3 = chs1.
ls3 = ls1.

ch = l1.
l1 = ch.
ch = l1 + l1.
l1 = ch + ch.
l1 = l1 + ch + ch.

message string(ch2) string(l2).
ch = "foo".
l1 = "foo".
message ch = l1. /* yes */
message string(ch) string(l1).

message string(lcfunc0("test1"))
        string(lcfunc0(ch))
        string(lcfunc0(l1))
        string(lcfunc0(ch + ch + l1))
        string(lcfunc0(substring(ch, 1)))
        string(lcfunc0(lcfunc0(substring(ch, 1))))
        string(lcfunc0(lcfunc2(substring(ch, 1))))
        string(lcfunc0(dynamic-function("lcfunc0", ch)))
        string(dynamic-function("lcfunc0")).

message string(lcfunc1(output l1))
        string(dynamic-function("lcfunc1", output ch))
        string(dynamic-function("lcfunc1", output l1)).
        
message string(chfunc0("test1"))
        string(chfunc0(ch))
        string(chfunc0(l1))
        string(chfunc0(ch + ch + l1))
        string(chfunc0(substring(ch, 1)))
        string(chfunc0(chfunc0(substring(ch, 1))))
        string(chfunc0(chfunc2(substring(ch, 1))))
        string(chfunc0(dynamic-function("chfunc0", ch)))
        string(dynamic-function("chfunc0")).

message string(chfunc1(output ch))
        string(chfunc1(output l1))
        string(dynamic-function("chfunc1", output ch))
        string(dynamic-function("chfunc1", output l1)).